/*
 *	Librairie RIMM
 *	fichier en tete a inclure par le client : RIMM_ldg.h
 *
 * Dvelopp par Arnaud BERCEGEAY <bercegeay@atari.org>
 *
 */

#ifndef __RIMM_LDG__
#define __RIMM_LDG__

#include <ldg.h>

typedef struct rim_struct
{
	char  Header_RIM [8] ;    /* 'READ_IMG' si tout va bien   */
	char  Format_RIM [4] ;    /* '_VDI' ou '_SHI' ou '_VSH'   */
	short Type_RIM ;          /* 0 : RIM total                */
	                          /* 1 : RIM partiel              */
	                          /* 2 : RIM gnrant             */
	                          /* 3 : RIM gnrant             */
	char  Id_RIM     [8] ;    /* ID du RIM sur 8 caractres   */
	short Version_RIM    ;    /* version du RIM               */
	char  Description[31];    /* 30 caractres + octet nul    */
	char  Configurable   ;    /* 1 si le RIM est configurable */
} RIMINFOS ;

typedef struct rimimg_struct
{
	long  rsvd1;          /* champ rserv...                       */
	short width;          /* largeur de l'image                     */
	short height;         /* hauteur de l'image                     */
	short wdwidth;        /* largeur des plans en nb de mots        */
	short stand;          /* standard utilis : 0 | 1               */
	short nplanes;        /* nb de plans de l'image                 */
	long  rsvd2;          /* champ reserve...                       */
	short rsvd3;          /* champ reserve...                       */
	long   size_palette;  /* taille de la palette                   */
	char * buff_palette;  /* buffer contenant la palette            */
	long   size_img;      /* mmoire ncessaire pour charger l'image*/
	char * buff_img;      /* buffer o sera charge l'image         */
	long   size_R8V8B8;   /* mmoire pour l'image en 24b            */
	char * buff_R8V8B8;   /* et son buffer                          */
	RIMINFOS * riminfos;  /* pointeur sur le RIM charg en mmoire  */
} RIMIMG;


extern long cdecl (*RIMM_OpenImg)(RIMIMG * rimimg, char * filename, long mode);
extern long cdecl (*RIMM_CloseImg)(RIMIMG * rimimg);
extern long cdecl (*RIMM_LoadImg)(RIMIMG * rimimg);
extern long cdecl (*RIMM_LoadImg_R8V8B8)(RIMIMG * rimimg, short * global);
extern long cdecl (*RIMM_LoadImg_R8V8B8_to_disk)(RIMIMG * rimimg, long Fh_R8V8B8, short * global);
extern void cdecl (*RIMM_CompressPalette)( char * palette, long size);
extern void cdecl (*RIMM_ExplainError)( short * global);
extern void cdecl (*RIMM_Init)( short * global, long mode);

extern long cdecl init_ldg_rimm (LDG * ldg_rimm) ;
extern LDG *ldg_rimm;

#endif /* __RIMM_LDG__ */

/* EOF */
